unit uMain;

interface

{$I ver.inc}

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, StdCtrls, ComCtrls, DBCtrls, Spin, ExtCtrls, Grids,
  DBGrids, dbisamtb;

type
  TfmMain = class(TForm)
    DBGrid1: TDBGrid;
    Panel1: TPanel;
    lbProgress: TLabel;
    Label3: TLabel;
    bnInsert: TButton;
    bnClose: TButton;
    seRecQty: TSpinEdit;
    bnOpenTable: TButton;
    cbLocalDatabase: TCheckBox;
    bnRecNo: TButton;
    DBNavigator1: TDBNavigator;
    reLog: TRichEdit;
    DataSource1: TDataSource;
    bnEdit: TButton;
    bnDelete: TButton;
    bnRead: TButton;
    gbRemoteParams: TGroupBox;
    gbLocalParams: TGroupBox;
    Label1: TLabel;
    eHost: TEdit;
    Label2: TLabel;
    sePort: TSpinEdit;
    Label5: TLabel;
    eFile: TEdit;
    DBISAMTable1: TDBISAMTable;
    DBISAMRemoteSession: TDBISAMSession;
    DBISAMDatabase1: TDBISAMDatabase;
    DBISAMLocalSession: TDBISAMSession;
    procedure FormCreate(Sender: TObject);
    procedure cbLocalDatabaseClick(Sender: TObject);
    procedure bnOpenTableClick(Sender: TObject);
    procedure DBISAMTable1AfterClose(DataSet: TDataSet);
    procedure DBISAMTable1AfterOpen(DataSet: TDataSet);
    procedure bnInsertClick(Sender: TObject);
    procedure bnCloseClick(Sender: TObject);
    procedure bnReadClick(Sender: TObject);
    procedure bnRecNoClick(Sender: TObject);
    procedure bnEditClick(Sender: TObject);
    procedure bnDeleteClick(Sender: TObject);
  private
    { Private declarations }
    FClose: Boolean;
  public
    { Public declarations }
    procedure SetVCLEnabled(Value: Boolean);
    procedure SaveLog;
  end;

var
  fmMain: TfmMain;

implementation

{$R *.dfm}

procedure TfmMain.FormCreate(Sender: TObject);
begin
 Caption := 'Client-Server Basic Speed Test. DBISAM version: '+DBISAMTable1.EngineVersion+'. (c) AidAim Software, http://www.aidaim.com';
 FClose := False;
 DBISAMDatabase1.Close;
end;

procedure TfmMain.cbLocalDatabaseClick(Sender: TObject);
begin
 if (TCheckBox(Sender).Checked) then
  begin
   gbLocalParams.Enabled := True;
   gbRemoteParams.Enabled := False;
  end
 else
  begin
   gbLocalParams.Enabled := False;
   gbRemoteParams.Enabled := True;
  end;
end;

procedure TfmMain.bnOpenTableClick(Sender: TObject);
begin
 if (DBISAMTable1.Active) then
  begin
    DBISAMTable1.Close;
    DBISAMDatabase1.Close;
    TButton(Sender).Caption := 'Open table';
  end
 else
  begin
    DBISAMDatabase1.Close;
    if (cbLocalDatabase.Checked) then
     begin
       DBISAMLocalSession.Active := False;
       DBISAMLocalSession.PrivateDir := eFile.Text;
       DBISAMDatabase1.Directory := eFile.Text;
       DBISAMDatabase1.SessionName := DBISAMLocalSession.SessionName;
       DBISAMTable1.SessionName := DBISAMLocalSession.SessionName;
     end
    else
     begin
       DBISAMRemoteSession.Active := False;
       DBISAMRemoteSession.RemoteAddress := eHost.Text;
       DBISAMRemoteSession.RemoteHost := eHost.Text;
       DBISAMRemoteSession.RemotePort := sePort.Value;
       DBISAMDatabase1.SessionName := DBISAMRemoteSession.SessionName;
       DBISAMTable1.SessionName := DBISAMRemoteSession.SessionName;
     end;
    DBISAMDatabase1.Connected := true;
    if (not DBISAMTable1.Exists) then
     begin
      DBISAMTable1.IndexDefs.Clear;
      DBISAMTable1.FieldDefs.Clear;
      DBISAMTable1.FieldDefs.Add('ID',ftAutoInc);
      DBISAMTable1.FieldDefs.Add('Str',ftFixedChar,20);
      DBISAMTable1.IndexDefs.Add('PK','ID',[ixPrimary]);
      DBISAMTable1.IndexDefs.Add('Idx1','Str',[]);
      DBISAMTable1.CreateTable;
     end;
    DBISAMTable1.Open;
    DataSource1.DataSet := DBISAMTable1;
    TButton(Sender).Caption := 'Close table';
  end;
end;

procedure TfmMain.DBISAMTable1AfterClose(DataSet: TDataSet);
begin
  bnOpenTable.Caption := 'Open table';
  reLog.Lines.Add('Table closed, LocalDatabase = '+BoolToStr(cbLocalDatabase.Checked,True));
end;

procedure TfmMain.DBISAMTable1AfterOpen(DataSet: TDataSet);
begin
  bnOpenTable.Caption := 'Close table';
  reLog.Lines.Add('Table opened, RecordCount = '+IntToStr(DBISAMTable1.RecordCount)+', LocalDatabase = '+BoolToStr(cbLocalDatabase.Checked,True));
end;

procedure TfmMain.SetVCLEnabled(Value: Boolean);
begin
  if (Value) then
   begin
    DBISAMTable1.EnableControls;
   end
  else
   begin
    DBISAMTable1.DisableControls;
   end;
  bnInsert.Enabled := Value;
  bnEdit.Enabled := Value;
  bnDelete.Enabled := Value;
  bnRead.Enabled := Value;
  bnRecNo.Enabled := Value;
  seRecQty.Enabled := Value;
  eFile.Enabled := Value;
  eHost.Enabled := Value;
  sePort.Enabled := Value;
  reLog.Enabled := Value;
  cbLocalDatabase.Enabled := Value;
end;

procedure TfmMain.bnInsertClick(Sender: TObject);
var i,n,k,c,x:  Integer;
    t:          Cardinal;
    f:          Double;
begin
  if (not DBISAMTable1.Active) then
   bnOpenTableClick(bnOpenTable);
  SetVCLEnabled(False);
  t := GetTickCount;
  n := seRecQty.Value;
  try
    x := n div 100;
    c := DBISAMTable1.RecordCount;
    for i := 1 to n do
     begin
      if FClose then Exit;
      k := c+i;
      DBISAMTable1.Append;
      DBISAMTable1.FieldByName('Str').AsString := 'test_'+FormatFloat('000000000',k);
      DBISAMTable1.Post;
      if ((i mod x) = 0) then
       begin
        f := i / ((GetTickCount-t) + 0.000000001);
        lbProgress.Caption := IntToStr(i)+ ' '+FormatFloat('##0.000',f);
        Application.ProcessMessages;
       end;
     end;
  finally
    t := GetTickCount-t;
    f := t / 1000.0;
    reLog.Lines.Add('Insert '+IntToStr(n)+ ' records time, sec: '+#9+FormatFloat('#,##0.000',f));
    SetVCLEnabled(True);
    SaveLog;
  end;
end;

procedure TfmMain.bnCloseClick(Sender: TObject);
begin
  FClose := true;
  Close;
end;

procedure TfmMain.SaveLog;
begin
  reLog.Lines.SaveToFile(IncludeTrailingBackslash(ExtractFilePath(ParamStr(0)))+'log.txt');
end;

procedure TfmMain.bnReadClick(Sender: TObject);
var i,n,x:      Integer;
    t:          Cardinal;
    f:          Double;
    s:          String;
begin
  if (not DBISAMTable1.Active) then
   bnOpenTableClick(bnOpenTable);
  SetVCLEnabled(False);
  t := GetTickCount;
  n := seRecQty.Value;
  try
    x := n div 100;
    DBISAMTable1.First;
    i := 0;
    while (not DBISAMTable1.Eof) and (i < n) do
     begin
      if FClose then Exit;
      s := DBISAMTable1.FieldByName('Str').AsString;
      Inc(i);
      DBISAMTable1.Next;
      if ((i mod x) = 0) then
       begin
        f := i / ((GetTickCount-t) + 0.000000001);
        lbProgress.Caption := IntToStr(i)+ ' '+FormatFloat('##0.000',f);
        Application.ProcessMessages;
       end;
     end;
  finally
    t := GetTickCount-t;
    f := t / 1000.0;
    reLog.Lines.Add('Read '+IntToStr(n)+ ' records time, sec: '+#9+FormatFloat('#,##0.000',f));
    SetVCLEnabled(True);
    SaveLog;
  end;
end;

procedure TfmMain.bnRecNoClick(Sender: TObject);
var i,n,x:      Integer;
    t:          Cardinal;
    f:          Double;
begin
  if (not DBISAMTable1.Active) then
   bnOpenTableClick(bnOpenTable);
  SetVCLEnabled(False);
  t := GetTickCount;
  n := seRecQty.Value;
  try
    x := n div 100;
    for i := 1 to n do
     begin
      if FClose then Exit;
      DBISAMTable1.RecNo := i;
      if ((i mod x) = 0) then
       begin
        f := i / ((GetTickCount-t) + 0.000000001);
        lbProgress.Caption := IntToStr(i)+ ' '+FormatFloat('##0.000',f);
        Application.ProcessMessages;
       end;
     end;
  finally
    t := GetTickCount-t;
    f := t / 1000.0;
    reLog.Lines.Add('RecNo '+IntToStr(n)+ ' records time, sec: '+#9+FormatFloat('#,##0.000',f));
    SetVCLEnabled(True);
    SaveLog;
  end;
end;

procedure TfmMain.bnEditClick(Sender: TObject);
var i,n,x:      Integer;
    t:          Cardinal;
    f:          Double;
    s:          String;
begin
  if (not DBISAMTable1.Active) then
   bnOpenTableClick(bnOpenTable);
  SetVCLEnabled(False);
  t := GetTickCount;
  n := seRecQty.Value;
  try
    x := n div 100;
    DBISAMTable1.First;
    i := 0;
    while (not DBISAMTable1.Eof) and (i < n) do
     begin
      if FClose then Exit;
      s := DBISAMTable1.FieldByName('Str').AsString;
      DBISAMTable1.Edit;
      DBISAMTable1.FieldByName('Str').AsString := s + ' - Edited!';
      DBISAMTable1.Post;
      Inc(i);
      DBISAMTable1.Next;
      if ((i mod x) = 0) then
       begin
        f := i / ((GetTickCount-t) + 0.000000001);
        lbProgress.Caption := IntToStr(i)+ ' '+FormatFloat('##0.000',f);
        Application.ProcessMessages;
       end;
     end;
  finally
    t := GetTickCount-t;
    f := t / 1000.0;
    reLog.Lines.Add('Edit '+IntToStr(n)+ ' records time, sec: '+#9+FormatFloat('#,##0.000',f));
    SetVCLEnabled(True);
    SaveLog;
  end;
end;

procedure TfmMain.bnDeleteClick(Sender: TObject);
var i,n,x:      Integer;
    t:          Cardinal;
    f:          Double;
begin
  if (not DBISAMTable1.Active) then
   bnOpenTableClick(bnOpenTable);
  SetVCLEnabled(False);
  t := GetTickCount;
  n := seRecQty.Value;
  try
    x := n div 100;
    DBISAMTable1.First;
    i := 0;
    while (not DBISAMTable1.Eof) and (i < n) do
     begin
      if FClose then Exit;
      DBISAMTable1.Delete;
      Inc(i);
      if ((i mod x) = 0) then
       begin
        f := i / ((GetTickCount-t) + 0.000000001);
        lbProgress.Caption := IntToStr(i)+ ' '+FormatFloat('##0.000',f);
        Application.ProcessMessages;
       end;
     end;
  finally
    t := GetTickCount-t;
    f := t / 1000.0;
    reLog.Lines.Add('Delete '+IntToStr(n)+ ' records time, sec: '+#9+FormatFloat('#,##0.000',f));
    SetVCLEnabled(True);
    SaveLog;
  end;
end;

end.
